Subject: bug#75392: “Failed to read private key” error with libssh 0.11.1

From: Ludovic Courtès <[email-masked]>
Date: Tue, 07 Jan 2025 10:07:04 +0100

Hello,

> It would seem that somehow libssh dismisses whatever gpg-agent tells it
> and then goes on to read key files directly.

Turns out the problem was sorta between keyboard and chair, but not
just!

Namely:

  1. libssh 0.11.x no longer recognizes DSA keys (which is reasonable),
     and it would choke when encountering one: “Unknown key type
     found!”, from ‘ssh_pki_import_pubkey_blob’.

  2. I had stale DSA keys under ~/.ssh, so I removed them.

  3. Problem: silly gpg-agent (which I use with ‘--enable-ssh-support’)
     would keep serving those DSA keys that I had removed!  Turns out it
     caches private keys under ~/.gnupg/private-keys-v1.d so I also had
     to remove them as well.

After that, everything went well.  Pfew.

Ludo’.